/*
 * libslb.h - internal header file.
 * Used only when compiling the shared library code,
 * to redirect standard library functions to the
 * library that was linked to the application
 *
 * Copyright (C) 2018 Thorsten Otto
 *
 * For conditions of distribution and use, see the accompanying README file.
 */

#ifndef __JPEGLIBSLB_H__
#define __JPEGLIBSLB_H__ 1

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <math.h>

#undef stderr

#undef memset
#undef memcpy
#undef strncpy

#undef malloc
#undef free
#undef exit

#undef fprintf
#undef sprintf
#undef fread
#undef fwrite
#undef fflush
#undef ferror

#include "libstrct.h"

struct _jpeglibslb_funcs *jpeglib_get_slb_funcs(void);

#define memset(d, c, l) jpeglib_get_slb_funcs()->p_memset(d, c, l)
#define memcpy(d, s, l) jpeglib_get_slb_funcs()->p_memcpy(d, s, l)
#define strncpy(d, s, l) jpeglib_get_slb_funcs()->p_strncpy(d, s, l)

#define malloc jpeglib_get_slb_funcs()->p_malloc
#define free jpeglib_get_slb_funcs()->p_free
#define exit jpeglib_get_slb_funcs()->p_exit

#define stderr (jpeglib_get_slb_funcs()->stderr_location)

#define fprintf jpeglib_get_slb_funcs()->p_fprintf
#define sprintf jpeglib_get_slb_funcs()->p_sprintf
#define fread jpeglib_get_slb_funcs()->p_fread
#define fwrite jpeglib_get_slb_funcs()->p_fwrite
#define fflush jpeglib_get_slb_funcs()->p_fflush
#define ferror jpeglib_get_slb_funcs()->p_ferror

#endif /* __JPEGLIBSLB_H__ */
